"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.heliumAddressFromSolAddress = exports.heliumAddressFromSolKey = exports.heliumAddressToSolAddress = exports.heliumAddressToSolPublicKey = exports.getSolanaKeypair = exports.humanReadable = exports.humanReadableBigint = exports.roundToDecimals = exports.numberWithCommas = exports.supplyAsNum = exports.toBN = exports.amountAsNum = exports.toNumber = exports.truthy = void 0;
const bn_js_1 = __importDefault(require("bn.js"));
const web3_js_1 = require("@solana/web3.js");
const address_1 = __importStar(require("@helium/address"));
const truthy = (value) => !!value;
exports.truthy = truthy;
function toNumber(numberOrBn, mintOrDecimals) {
    if (bn_js_1.default.isBN(numberOrBn) || typeof numberOrBn == "bigint") {
        return amountAsNum(numberOrBn, mintOrDecimals);
    }
    else {
        return numberOrBn;
    }
}
exports.toNumber = toNumber;
function amountAsNum(amount, mintOrDecimals) {
    const decimals = typeof mintOrDecimals === "number"
        ? mintOrDecimals
        : mintOrDecimals.decimals;
    const factor = new bn_js_1.default(Math.pow(10, decimals).toString());
    const decimal = new bn_js_1.default(amount.toString()).mod(factor).toNumber() / factor.toNumber();
    return new bn_js_1.default(amount.toString()).div(factor).toNumber() + decimal;
}
exports.amountAsNum = amountAsNum;
function toBN(numberOrBn, mintOrDecimals) {
    const decimals = typeof mintOrDecimals === "number"
        ? mintOrDecimals
        : mintOrDecimals.decimals;
    if (bn_js_1.default.isBN(numberOrBn)) {
        return numberOrBn;
    }
    else {
        return new bn_js_1.default(Number(Math.floor(Number(numberOrBn))))
            .mul(new bn_js_1.default(Math.pow(10, decimals)))
            .add(new bn_js_1.default(Math.round((Number(numberOrBn) % 1) * Math.pow(10, decimals))));
    }
}
exports.toBN = toBN;
function supplyAsNum(mint) {
    return amountAsNum(new bn_js_1.default(mint.supply.toString()), mint);
}
exports.supplyAsNum = supplyAsNum;
function numberWithCommas(x, decimals = 4) {
    return roundToDecimals(x, decimals).toLocaleString("en-US", {
        maximumFractionDigits: decimals,
    });
}
exports.numberWithCommas = numberWithCommas;
function roundToDecimals(num, decimals) {
    return Math.trunc(num * Math.pow(10, decimals)) / Math.pow(10, decimals);
}
exports.roundToDecimals = roundToDecimals;
function humanReadableBigint(bigint, decimals, round = decimals) {
    return numberWithCommas(roundToDecimals(toNumber(bigint, decimals), round));
}
exports.humanReadableBigint = humanReadableBigint;
function humanReadable(bn, decimalsOrMint) {
    return numberWithCommas(roundToDecimals(toNumber(bn, decimalsOrMint), typeof decimalsOrMint == "number"
        ? decimalsOrMint
        : decimalsOrMint.decimals));
}
exports.humanReadable = humanReadable;
const getSolanaKeypair = (secretKey) => web3_js_1.Keypair.fromSecretKey(Buffer.from(secretKey, "base64"));
exports.getSolanaKeypair = getSolanaKeypair;
const heliumAddressToSolPublicKey = (heliumAddress) => {
    const heliumPK = address_1.default.fromB58(heliumAddress).publicKey;
    return new web3_js_1.PublicKey(heliumPK);
};
exports.heliumAddressToSolPublicKey = heliumAddressToSolPublicKey;
const heliumAddressToSolAddress = (heliumAddress) => {
    return (0, exports.heliumAddressToSolPublicKey)(heliumAddress).toBase58();
};
exports.heliumAddressToSolAddress = heliumAddressToSolAddress;
const heliumAddressFromSolKey = (pubKey) => {
    return new address_1.default(0, address_1.NetTypes.MAINNET, address_1.KeyTypes.ED25519_KEY_TYPE, pubKey.toBuffer()).b58;
};
exports.heliumAddressFromSolKey = heliumAddressFromSolKey;
const heliumAddressFromSolAddress = (solAddress) => {
    try {
        const pubKey = new web3_js_1.PublicKey(solAddress);
        return (0, exports.heliumAddressFromSolKey)(pubKey);
    }
    catch (_a) {
        return "";
    }
};
exports.heliumAddressFromSolAddress = heliumAddressFromSolAddress;
//# sourceMappingURL=utils.js.map